<script setup lang="ts">
import { useBillStore } from '@/stores/bill'
import { useTypeBillStore } from '@/stores/typebill'
import type { Bill } from '@/types/Bill'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Date',
    key: 'dateAt',
    value: 'dateAt'
  },
  {
    title: 'Type',
    key: 'typeBill'
  },
  {
    title: 'Price',
    key: 'price'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const useTypeBill = useTypeBillStore()
const useBill = useBillStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
function onSubmit() {}

async function editItem(item: Bill) {
  if (!item.id) return
  await useBill.getBill(item.id)
  dialog.value = true
}
async function deleteItem(item: Bill) {
  if (!item.id) return
  await useBill.getBill(item.id)
  dialogDelete.value = true
}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    useBill.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await useBill.deleteBill()
  closeDelete()
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    useBill.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await useBill.saveBill()
  closeDialog()
}
onMounted(async () => {
  await useBill.getBills()
})
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="useBill.bills" height="calc(90vh - 200px)">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Bills</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New Bill </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Bill Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="useBill.editedBill.dateAt"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Date"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-col cols="12" sm="6">
                          <v-combobox
                            v-model="useBill.editedBill.typebill"
                            :items="useTypeBill.typebills"
                            item-title="name"
                            item-value="id"
                            label="Select unit"
                            :return-object="true"
                          ></v-combobox>
                        </v-col>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="useBill.editedBill.price"
                          class="mb-2"
                          clearable
                          label="Price"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>

      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
    </v-data-table>
  </div>
</template>
